diff -ur snort-2.0.2/src/decode.c snort-2.0.2-ipv6/src/decode.c
--- snort-2.0.2/src/decode.c	Wed Aug  6 23:26:06 2003
+++ snort-2.0.2-ipv6/src/decode.c	Thu Nov 20 15:21:42 2003
@@ -1,4 +1,4 @@
-/* $Id: decode.c,v 1.101 2003/08/06 14:26:06 chrisgreen Exp $ */
+/* $Id: decode.c,v 1.4 2003/11/07 07:11:59 abekatsu Exp $ */
 
 /*
 ** Copyright (C) 1998-2002 Martin Roesch <roesch@sourcefire.com>
@@ -124,7 +124,7 @@
 
         case ETHERNET_TYPE_IPV6:
             DecodeIPV6(p->pkt + ETHERNET_HEADER_LEN, 
-                    (cap_len - ETHERNET_HEADER_LEN));
+                    (cap_len - ETHERNET_HEADER_LEN), p);
             return;
 
         case ETHERNET_TYPE_IPX:
@@ -945,7 +945,7 @@
             return;
 
         case ETHERNET_TYPE_IPV6:
-            DecodeIPV6(p->pkt + SLL_HDR_LEN, (cap_len - SLL_HDR_LEN));
+            DecodeIPV6(p->pkt + SLL_HDR_LEN, (cap_len - SLL_HDR_LEN), p);
             return;
 
         case ETHERNET_TYPE_IPX:
@@ -1042,7 +1042,7 @@
 
 #ifdef AF_INET6
         case AF_INET6:  /* IPv6 */
-            DecodeIPV6(p->pkt + PFLOG_HDRLEN, (cap_len - PFLOG_HDRLEN));
+            DecodeIPV6(p->pkt + PFLOG_HDRLEN, (cap_len - PFLOG_HDRLEN), p);
             return;
 #endif
 
@@ -2219,6 +2219,154 @@
 
 
 /*
+ * Function: DecodeTCP6(u_int8_t *, const u_int32_t, Packet *)
+ *
+ * Purpose: Decode the TCP transport layer over IPv6
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => Pointer to packet decode struct
+ *
+ * Returns: void function
+ */
+void DecodeTCP6(u_int8_t * pkt, const u_int32_t len, Packet * p)
+{
+    u_int32_t hlen;            /* TCP header length */
+    u_short csum;              /* checksum */     
+    Event event;
+
+    if(len < 20)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("TCP packet (len = %d) cannot contain "
+                         "20 byte header\n", len);
+        }
+
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts) 
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                    DECODE_TCP_DGRAM_LT_TCPHDR, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_TCP_DGRAM_LT_TCPHDR_STR, NULL, &event);
+            CallLogFuncs(p, DECODE_TCP_DGRAM_LT_TCPHDR_STR, NULL, &event);
+        }
+
+        p->tcph = NULL;
+        pc.discards++;
+        return;
+    }
+
+    /* lay TCP on top of the data cause there is enough of it! */
+    p->tcph = (TCPHdr *) pkt;
+
+    /* multiply the payload offset value by 4 */
+    hlen = TCP_OFFSET(p->tcph) << 2;
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "TCP th_off is %d, passed len is %lu\n", 
+                TCP_OFFSET(p->tcph), (unsigned long)len););
+
+    if(hlen < 20)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("TCP Data Offset (%d) < hlen (%d) \n",
+                         TCP_OFFSET(p->tcph), hlen);
+        }
+
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                    DECODE_TCP_INVALID_OFFSET, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_TCP_INVALID_OFFSET_STR, NULL, &event);
+            CallLogFuncs(p, DECODE_TCP_INVALID_OFFSET_STR, NULL, &event);
+        }
+
+        p->tcph = NULL;
+        pc.discards++;
+
+        return;
+    }
+
+    if(hlen > len)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("TCP Data Offset(%d) < longer than payload(%d)!\n",
+                         TCP_OFFSET(p->tcph) << 2, len);
+        }
+
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                    DECODE_TCP_LARGE_OFFSET, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_TCP_LARGE_OFFSET_STR, NULL, &event);
+            CallLogFuncs(p, DECODE_TCP_LARGE_OFFSET_STR, NULL, &event);
+        }
+
+        p->tcph = NULL;
+        pc.discards++;
+
+        return;
+    }
+
+    if(pv.checksums_mode & DO_TCP_CHECKSUMS)
+    {
+        /* if we're being "stateless" we probably don't care about the TCP 
+         * checksum, but it's not bad to keep around for shits and giggles */
+        /* calculate the checksum */
+        /* csum = in_chksum_tcp((u_int16_t *)&ph, (u_int16_t *)(p->tcph), len); */
+        csum = ipv6_checksum(p, (u_int16_t *)(p->tcph), len);
+        
+        if(csum)
+        {
+            p->csum_flags |= CSE_TCP;
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "Bad TCP checksum\n",
+                                    "0x%x versus 0x%x\n", csum,
+                                    ntohs(p->tcph->th_sum)););
+        }
+        else
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE,"TCP Checksum: OK\n"););
+        }
+    }
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "tcp header starts at: %p\n", p->tcph););
+
+    /* stuff more data into the printout data struct */
+    p->sp = ntohs(p->tcph->th_sport);
+    p->dp = ntohs(p->tcph->th_dport);
+
+    /* if options are present, decode them */
+    p->tcp_options_len = hlen - 20;
+    
+    if(p->tcp_options_len > 0)
+    {
+        DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "%lu bytes of tcp options....\n", 
+                    (unsigned long)(p->tcp_options_len)););
+
+        p->tcp_options_data = pkt + 20;
+        DecodeTCPOptions((u_int8_t *) (pkt + 20), p->tcp_options_len, p);
+    }
+    else
+    {
+        p->tcp_option_count = 0;
+    }
+
+    /* set the data pointer and size */
+    p->data = (u_int8_t *) (pkt + hlen);
+
+    if(hlen < len)
+    {
+        p->dsize = (u_short)(len - hlen);
+    }
+    else
+    {
+        p->dsize = 0;
+    }
+}
+
+
+/*
  * Function: DecodeUDP(u_int8_t *, const u_int32_t, Packet *)
  *
  * Purpose: Decode the UDP transport layer
@@ -2362,86 +2510,215 @@
     return;
 }
 
-
-
 /*
- * Function: DecodeICMP(u_int8_t *, const u_int32_t, Packet *)
+ * Function: DecodeUDP6(u_int8_t *, const u_int32_t, Packet *)
  *
- * Purpose: Decode the ICMP transport layer
+ * Purpose: Decode the UDP transport layer
  *
  * Arguments: pkt => ptr to the packet data
  *            len => length from here to the end of the packet
- *            p   => pointer to the decoded packet struct
+ *            p   => pointer to decoded packet struct  
  *
  * Returns: void function
  */
-void DecodeICMP(u_int8_t * pkt, const u_int32_t len, Packet * p)
+void DecodeUDP6(u_int8_t * pkt, const u_int32_t len, Packet * p)
 {
-    u_int16_t csum;
+    u_short csum;
+    u_int16_t uhlen;
     Event event;
-    u_int16_t orig_p_caplen;
 
-    if(len < ICMP_HEADER_LEN)
+    if(len < sizeof(UDPHdr))
     {
         if(pv.verbose_flag)
         {
-            ErrorMessage("WARNING: Truncated ICMP header "
-                         "(%d bytes)\n", len);
+            ErrorMessage("Truncated UDP header (%d bytes)\n", len);
         }
-        
-        p->icmph = NULL;
+
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts) 
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                    DECODE_UDP_DGRAM_LT_UDPHDR, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_UDP_DGRAM_LT_UDPHDR_STR, 
+                    NULL, &event);
+            CallLogFuncs(p, DECODE_UDP_DGRAM_LT_UDPHDR_STR,
+                    NULL, &event);
+            DisableDetect(p);
+        }
+
+        p->udph = NULL;
         pc.discards++;
 
         return;
     }
 
-    /* set the header ptr first */
-    p->icmph = (ICMPHdr *) pkt;
+    /* set the ptr to the start of the UDP header */
+    p->udph = (UDPHdr *) pkt;
 
-    switch (p->icmph->type)
+    uhlen = ntohs(p->udph->uh_len); 
+    
+    /* verify that the header len is a valid value */
+    if(uhlen < UDP_HEADER_LEN)
     {
-        case ICMP_ECHOREPLY:
-        case ICMP_DEST_UNREACH:
-        case ICMP_SOURCE_QUENCH:
-        case ICMP_REDIRECT:
-        case ICMP_ECHO:
-        case ICMP_ROUTER_ADVERTISE:
-        case ICMP_ROUTER_SOLICIT:
-        case ICMP_TIME_EXCEEDED:
-        case ICMP_PARAMETERPROB:
-        case ICMP_INFO_REQUEST:
-        case ICMP_INFO_REPLY:
-            if (len < 8)
-            {
-                if(pv.verbose_flag)
-                {
-                    ErrorMessage("Truncated ICMP header(%d bytes)\n", len);
-                }
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("Invalid UDP Packet, length field < 8");
+        }
+        
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                    DECODE_UDP_DGRAM_INVALID_LENGTH, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_UDP_DGRAM_INVALID_LENGTH_STR, NULL, 
+                    &event);
+            CallLogFuncs(p, DECODE_UDP_DGRAM_INVALID_LENGTH_STR, NULL, &event);
+            DisableDetect(p);
+        }
+        p->udph = NULL;
+        pc.discards++;
 
-                if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
-                {
-                    SetEvent(&event, GENERATOR_SNORT_DECODE, 
-                            DECODE_ICMP_DGRAM_LT_ICMPHDR, 1, DECODE_CLASS, 5, 0);
-                    CallAlertFuncs(p, DECODE_ICMP_DGRAM_LT_ICMPHDR_STR, 
-                            NULL, &event);
-                    CallLogFuncs(p, DECODE_ICMP_DGRAM_LT_ICMPHDR_STR,
-                            NULL, &event);
-                }
+        return;
+    }
 
-                p->icmph = NULL;
-                pc.discards++;
+    /* make sure there are enough bytes as designated by length field */
+    if(len < uhlen)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("Short UDP packet, length field > payload length\n");
+        }
 
-                return;
-            }
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts) 
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                    DECODE_UDP_DGRAM_SHORT_PACKET, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_UDP_DGRAM_SHORT_PACKET_STR, NULL, &event);
+            CallLogFuncs(p, DECODE_UDP_DGRAM_SHORT_PACKET_STR, NULL, &event);
+            DisableDetect(p);                   
+        }
 
-            break;
+        p->udph = NULL;
+        pc.discards++;
 
-        case ICMP_TIMESTAMP:
-        case ICMP_TIMESTAMPREPLY:
-            if (len < 20)
-            {
-                if(pv.verbose_flag)
-                {
+        return;
+    }
+
+    if(pv.checksums_mode & DO_UDP_CHECKSUMS)
+    {
+        /* look at the UDP checksum to make sure we've got a good packet */
+        if(p->udph->uh_chk)
+        {
+            csum = ipv6_checksum(p, (u_int16_t *)(p->udph), (u_int32_t) uhlen);
+        }
+        else
+        {
+            csum = 0;
+        }
+
+        if(csum)
+        {
+            p->csum_flags |= CSE_UDP;
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "Bad UDP Checksum\n"););
+            DisableDetect(p);
+        }
+        else
+        {
+            DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "UDP Checksum: OK\n"););
+        }
+    }
+
+    DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "UDP header starts at: %p\n", p->udph););
+
+    /* fill in the printout data structs */
+    p->sp = ntohs(p->udph->uh_sport);
+    p->dp = ntohs(p->udph->uh_dport);
+
+    p->data = (u_int8_t *) (pkt + UDP_HEADER_LEN);
+    
+    /* length was validated up above */
+    p->dsize = uhlen - UDP_HEADER_LEN; 
+
+    return;
+}
+
+
+/*
+ * Function: DecodeICMP(u_int8_t *, const u_int32_t, Packet *)
+ *
+ * Purpose: Decode the ICMP transport layer
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => pointer to the decoded packet struct
+ *
+ * Returns: void function
+ */
+void DecodeICMP(u_int8_t * pkt, const u_int32_t len, Packet * p)
+{
+    u_int16_t csum;
+    Event event;
+    u_int16_t orig_p_caplen;
+
+    if(len < ICMP_HEADER_LEN)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("WARNING: Truncated ICMP header "
+                         "(%d bytes)\n", len);
+        }
+        
+        p->icmph = NULL;
+        pc.discards++;
+
+        return;
+    }
+
+    /* set the header ptr first */
+    p->icmph = (ICMPHdr *) pkt;
+
+    switch (p->icmph->type)
+    {
+        case ICMP_ECHOREPLY:
+        case ICMP_DEST_UNREACH:
+        case ICMP_SOURCE_QUENCH:
+        case ICMP_REDIRECT:
+        case ICMP_ECHO:
+        case ICMP_ROUTER_ADVERTISE:
+        case ICMP_ROUTER_SOLICIT:
+        case ICMP_TIME_EXCEEDED:
+        case ICMP_PARAMETERPROB:
+        case ICMP_INFO_REQUEST:
+        case ICMP_INFO_REPLY:
+            if (len < 8)
+            {
+                if(pv.verbose_flag)
+                {
+                    ErrorMessage("Truncated ICMP header(%d bytes)\n", len);
+                }
+
+                if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+                {
+                    SetEvent(&event, GENERATOR_SNORT_DECODE, 
+                            DECODE_ICMP_DGRAM_LT_ICMPHDR, 1, DECODE_CLASS, 5, 0);
+                    CallAlertFuncs(p, DECODE_ICMP_DGRAM_LT_ICMPHDR_STR, 
+                            NULL, &event);
+                    CallLogFuncs(p, DECODE_ICMP_DGRAM_LT_ICMPHDR_STR,
+                            NULL, &event);
+                }
+
+                p->icmph = NULL;
+                pc.discards++;
+
+                return;
+            }
+
+            break;
+
+        case ICMP_TIMESTAMP:
+        case ICMP_TIMESTAMPREPLY:
+            if (len < 20)
+            {
+                if(pv.verbose_flag)
+                {
                     ErrorMessage("Truncated ICMP header(%d bytes)\n", len);
                 }
 
@@ -2760,24 +3037,442 @@
     return;
 }
 
-
 /*
- * Function: DecodeIPV6(u_int8_t *, u_int32_t)
+ * Function: DecodeIPV6(u_int8_t *, u_int32_t, Packet *)
  *
- * Purpose: Just like IPX, it's just for counting.
+ * Purpose: Decode the IPv6 network layer
  *
  * Arguments: pkt => ptr to the packet data
  *            len => length from here to the end of the packet
+ *            p   => pointer to the packet decode struct
  *
  * Returns: void function
  */
-void DecodeIPV6(u_int8_t *pkt, u_int32_t len)
+void DecodeIPV6(u_int8_t *pkt, u_int32_t len, Packet *p)
 {
-    DEBUG_WRAP(DebugMessage(DEBUG_DECODE, "IPv6 is not supported.\n"););
+    u_int8_t version;
+    u_int16_t plen;
+    Event event;                /* event */
+
     pc.ipv6++;
+
+    p->ip6h = (IP6Hdr *) pkt;
+
+    /* do a little validation */
+    if(len < IP6_HEADER_LEN)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("IPv6 header truncated! (%d bytes)\n", len);
+        }
+        p->ip6h = NULL;
+
+        return;
+    }    
+
+    /* Check Version Field */
+    version = (p->ip6h->s_ip6_vfc & 0xf0) >> 4;
+    plen = ntohs(p->ip6h->s_ip6_plen);
+
+    if ( version != 6 ) 
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("[!] WARNING: Not IPv6 datagram!"
+                         "([ver: 0x%x][len: 0x%x])\n", 
+                         version, plen + IP6_HEADER_LEN);
+        }
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE,
+		     DECODE_NOT_IPV6_DGRAM, 1, DECODE_CLASS, 5, 0);
+            CallAlertFuncs(p, DECODE_NOT_IPV6_DGRAM_STR, NULL, &event);
+	    CallLogFuncs(p, DECODE_NOT_IPV6_DGRAM_STR, NULL, &event);
+
+        }
+        p->ip6h = NULL;
+        pc.discards++;
+
+        return;
+    }
+
+    switch(p->ip6h->s_ip6_nxt)
+    {
+        case IPPROTO_TCP:
+            pc.tcp++;
+            DecodeTCP6(pkt + IP6_HEADER_LEN, plen, p);
+            ClearDumpBuf();
+            return;
+
+        case IPPROTO_UDP:
+            pc.udp++;
+            DecodeUDP6(pkt + IP6_HEADER_LEN, plen, p);
+            ClearDumpBuf();
+            return;
+
+        case IPPROTO_ICMPV6:
+            pc.icmpv6++;
+            DecodeICMPV6(pkt + IP6_HEADER_LEN, plen, p);
+            ClearDumpBuf();
+            return;
+
+        case IPPROTO_FRAGMENT:
+            pc.ip6frags++;
+            DecodeIP6Frag(pkt + IP6_HEADER_LEN, plen, p);
+            ClearDumpBuf();
+            return;
+
+        case IPPROTO_HOPOPTS:
+        case IPPROTO_ROUTING:
+        case IPPROTO_NONE:
+        case IPPROTO_DSTOPTS:
+            DecodeIP6Opt(pkt + IP6_HEADER_LEN, plen, p);
+	    return;
+
+        default:
+            pc.other++;
+            p->data = pkt + IP6_HEADER_LEN;
+            p->dsize = (u_short) plen;
+            ClearDumpBuf();
+            return;
+    }
+
     return;
 }
 
+/*
+ * Function: DecodeIP6Only(u_int8_t *, const u_int32_t, Packet *)
+ *
+ * Purpose: Decode the IP network layer but not recurse
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => pointer to dummy packet decode struct
+ *
+ * Returns: void function
+ */
+int DecodeIP6Only(u_int8_t * pkt, const u_int32_t len, Packet * p)
+{
+    u_int8_t version;
+    u_int16_t plen;
+
+    /* lay the IP struct over the raw data */
+    p->ip6h = (IP6Hdr *) pkt;
+
+#ifdef DEBUG
+    printf("DecodeIPv6Only: ip header starts at: %p, length is %lu\n", p->ip6h, (unsigned long) len);
+#endif
+
+    /* do a little validation */
+    if(len < IP6_HEADER_LEN)
+    {
+        ErrorMessage("ICMP Unreachable IPv6 short header (%d bytes)\n", len);
+        p->ip6h = NULL;
+        return(0);
+    }
+
+    version = (p->ip6h->s_ip6_vfc & 0xf0) >> 4;
+    plen = ntohs(p->ip6h->s_ip6_plen);
+    if(version != 6)
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("[!] WARNING: ICMP Unreachable not IPv6 datagram ([ver: 0x%x][len: 0x%x])\n", version, plen);
+        }
+
+        p->ip6h = NULL;
+
+        return(0);
+    }
+
+    switch(p->ip6h->s_ip6_nxt)
+    {
+        case IPPROTO_TCP: /* decode the interesting part of the header */
+            if(plen > 4)
+            {
+                p->tcph =(TCPHdr *)(pkt + IP6_HEADER_LEN);
+                /* stuff more data into the printout data struct */
+                p->sp = ntohs(p->tcph->th_sport);
+                p->dp = ntohs(p->tcph->th_dport);
+            }
+
+            break;
+
+        case IPPROTO_UDP:
+            if(plen > 4)
+            {
+                p->udph = (UDPHdr *)(pkt + IP6_HEADER_LEN);
+                /* fill in the printout data structs */
+                p->sp = ntohs(p->udph->uh_sport);
+                p->dp = ntohs(p->udph->uh_dport);
+            }
+
+            break;
+    }
+
+    return(1);
+}
+
+
+/*
+ * Function: DecodeIP6Frag(u_int8_t *, const u_int32_t, Packet *)
+ *
+ * Purpose: Decode the IPv6 Fragment Header
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => pointer to the decoded packet struct
+ *
+ * Returns: void function
+ */
+void DecodeIP6Frag(u_int8_t * pkt, const u_int32_t len, Packet * p)
+{
+    Event event;                /* event */
+    if(!p->ip6h)
+        return;
+
+    if(len < sizeof(IP6Frag))
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("[!] WARNING: Truncated IPv6 Fragment header(%d bytes)\n", len);
+        }
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE,
+                    DECODE_TRUNCATED_IPV6_FRAG_HDR, 1, 0, 5, 0);
+            CallAlertFuncs(p, DECODE_TRUNCATED_IPV6_FRAG_HDR_STR,
+                    NULL, &event);
+            CallLogFuncs(p, DECODE_TRUNCATED_IPV6_FRAG_HDR_STR,
+                    NULL, &event);
+        }
+         
+        p->ip6fh = NULL;
+        pc.discards++;
+
+        return;
+    }
+
+    /* set the header ptr first */
+    p->ip6fh = (IP6Frag *) pkt;
+
+    return;
+}
+
+/*
+ * Function: DecodeIP6Opt(u_int8_t *, const u_int32_t, Packet *)
+ *
+ * Purpose: Decode the IPv6 Option Header
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => pointer to the decoded packet struct
+ *
+ * Returns: void function
+ */
+void DecodeIP6Opt(u_int8_t * pkt, const u_int32_t len, Packet * p)
+{
+    u_int8_t nextheader;
+    u_int8_t hdrextlen;
+    u_int16_t plen;
+
+    if(!p->ip6h)
+        return;
+
+    nextheader = p->ip6h->s_ip6_nxt;
+    plen = len;
+
+    while(1)
+    {
+        if(plen<2) /* size of NextHeader field + HeaderLength field */
+            return;
+
+        switch(nextheader)
+        {
+            case IPPROTO_TCP:
+                pc.tcp++;
+                DecodeTCP(pkt, plen, p);
+                ClearDumpBuf();
+                return;
+
+            case IPPROTO_UDP:
+                pc.udp++;
+                DecodeUDP(pkt, plen, p);
+                ClearDumpBuf();
+                return;
+
+            case IPPROTO_ICMPV6:
+                pc.icmpv6++;
+                DecodeICMPV6(pkt, plen, p);
+                ClearDumpBuf();
+                return;
+
+            case IPPROTO_HOPOPTS:
+            case IPPROTO_DSTOPTS:
+            case IPPROTO_ROUTING:
+		hdrextlen =  (*(pkt+1) + 1) * 8;  /* 8 octet units */
+		if(p->ip6_option_count < MAX_IPv6_OPT)
+                {
+		    p->ip6_options[p->ip6_option_count].type = nextheader;
+		    p->ip6_options[p->ip6_option_count].next = *pkt;
+		    p->ip6_options[p->ip6_option_count].len = hdrextlen;
+		    p->ip6_options[p->ip6_option_count].data = pkt+2;
+                    p->ip6_option_count++;
+		}
+  	        nextheader = *pkt;
+		pkt += hdrextlen;
+		plen -= hdrextlen;
+		break;  
+
+            case IPPROTO_FRAGMENT:
+                pc.ip6frags++;
+                DecodeIP6Frag(pkt, plen, p);
+                ClearDumpBuf();
+                return;
+
+            case IPPROTO_NONE:
+	        return;
+
+	    default:
+                return;
+        }
+    }
+
+    return;
+}
+
+/*
+ * Function: DecodeICMPV6(u_int8_t *, const u_int32_t, Packet *)
+ *
+ * Purpose: Decode the ICMPv6 layer
+ *
+ * Arguments: pkt => ptr to the packet data
+ *            len => length from here to the end of the packet
+ *            p   => pointer to the decoded packet struct
+ *
+ * Returns: void function
+ */
+void DecodeICMPV6(u_int8_t * pkt, const u_int32_t len, Packet * p)
+{
+    u_int16_t csum;
+    Event event;                /* event */
+
+    if(len < sizeof(ICMP6Hdr))
+    {
+        if(pv.verbose_flag)
+        {
+            ErrorMessage("[!] WARNING: Truncated ICMPv6 header(%d bytes)\n", len);
+        }
+        if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+        {
+            SetEvent(&event, GENERATOR_SNORT_DECODE,
+                    DECODE_TRUNCATED_ICMPV6_HDR, 1, 0, 5, 0);
+            CallAlertFuncs(p, DECODE_TRUNCATED_ICMPV6_HDR_STR,
+                    NULL, &event);
+            CallLogFuncs(p, DECODE_TRUNCATED_ICMPV6_HDR_STR,
+                    NULL, &event);
+        }
+
+        p->icmp6h = NULL;
+        pc.discards++;
+
+        return;
+    }
+
+    /* set the header ptr first */
+    p->icmp6h = (ICMP6Hdr *) pkt;
+
+    if(pv.checksums_mode & DO_ICMP_CHECKSUMS)
+    {
+        csum = ipv6_checksum(p, (u_int16_t *)(p->icmp6h), len);
+
+        if(csum)
+        {
+            p->csum_flags |= CSE_ICMP6;
+
+#ifdef DEBUG
+            printf("Bad ICMPv6 Checksum\n");
+#endif
+        }
+#ifdef DEBUG
+        else
+        {
+            printf("ICMPv6 Checksum: OK\n");
+        }
+#endif
+    }
+
+    p->dsize = (u_short)(len - ICMP6_HEADER_LEN);
+    p->data = pkt + ICMP6_HEADER_LEN;
+
+#ifdef DEBUG
+    printf("ICMPv6 type: %d   code: %d\n", p->icmp6h->icmp6_type, p->icmp6h->code);
+#endif
+    switch(p->icmp6h->icmp6_type)
+    {
+        case ICMP6_ECHO_REPLY:
+            /* setup the pkt id ans seq numbers */
+            p->ext = (echoext *) (pkt + ICMP6_HEADER_LEN);
+            p->dsize -= sizeof(echoext);
+            p->data += sizeof(echoext);
+            break;
+        case ICMP6_ECHO_REQUEST:
+            /* setup the pkt id ans seq numbers */
+            p->ext = (echoext *) (pkt + ICMP6_HEADER_LEN);
+            p->dsize -= 4;      /* add the size of the echo ext to the data
+                         * ptr and subtract it from the data size */
+            p->data += 4;
+            break;
+        case ICMP6_DST_UNREACH:
+        case ICMP6_PACKET_TOO_BIG:
+        case ICMP6_TIME_EXCEEDED:
+        case ICMP6_PARAM_PROB:
+            {
+                Packet orig_p;
+
+                /* if unreach packet is smaller than expected! */
+                if(len < 16)
+                {
+                    if(pv.verbose_flag)
+                        ErrorMessage("[!] WARNING: Truncated ICMPv6-UNREACH header (%d bytes)\n", len);
+                    /* if it is less than 8 we are in trouble */
+                    if(len < 8)
+                        break;
+                }
+
+                bzero((char *)&orig_p, sizeof(Packet));
+                orig_p.caplen = len - 8;
+                if(DecodeIP6Only(pkt + 8, orig_p.caplen, &orig_p))
+                {
+
+                    /*
+                     * that's probably what we need to know about an original
+                     * datagram
+                     */
+                    p->orig_ip6h = orig_p.ip6h;
+                    p->orig_tcph = orig_p.tcph;
+                    p->orig_udph = orig_p.udph;
+                    p->orig_sp = orig_p.sp;
+                    p->orig_dp = orig_p.dp;
+                }
+                else
+                {
+                    if((runMode == MODE_IDS) && pv.decoder_flags.decode_alerts)
+                    {
+                        SetEvent(&event, GENERATOR_SNORT_DECODE,
+                                DECODE_IPV6_DGRAM_UNKNOWN, 1, 0, 5, 0);
+                        CallAlertFuncs(p, DECODE_IPV6_DGRAM_UNKNOWN_STR,
+                                NULL, &event);
+                        CallLogFuncs(p, DECODE_IPV6_DGRAM_UNKNOWN_STR,
+                                NULL, &event);
+                    }
+                }
+                break;
+            }
+    }
+
+    return;
+}
 
 /*
  * Function: DecodeIPX(u_int8_t *, u_int32_t)
